<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-select
              v-model="filter.nickname"
              :options="formattedProjectOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Owner</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.ownerName"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.projectName"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Kontrak</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.contractNumber"
              disabled
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-input
              id="input-large"
              size="lg"
              v-model="selectedNickname.status"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>

      <div class="d-flex justify-content-end pb-3">
        <div>
          <b-button
            v-if="currentEditId"
            class="ml-auto mr-2"
            variant="success"
            @click="save"
          >
            <i class="flaticon2-check-mark"></i> Simpan
          </b-button>

          <b-button class="ml-auto" variant="success" @click="loadData">
            Load Design
          </b-button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-4 offset-8">
            <div class="input-group mb-5">
              <div class="input-group-prepend">
                <span class="input-group-text line-height-0 py-0">
                  <i class="flaticon2-search-1"></i>
                </span>
              </div>

              <input
                type="text"
                class="form-control"
                aria-describedby="basic-addon2"
              />
            </div>
          </div>
        </div>

        <complete-table :loading="loading" :data="monitoringLogistics">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Numbering</span>
              </th>
              <th style="min-width: 250px">Title</th>
              <th style="min-width: 100px">Stasiun</th>
              <th style="min-width: 100px">Type</th>
              <th style="min-width: 100px">Scope</th>
              <th style="min-width: 100px">Status</th>
              <th style="min-width: 100px">Revisi</th>
              <th style="min-width: 100px">Versi</th>
              <th style="min-width: 150px">Receiver</th>
              <th style="min-width: 150px">Date Received</th>
              <th style="min-width: 150px">Aksi</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(item, i) in monitoringLogistics">
              <tr v-bind:key="i">
                <td class="pl-0 ">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.numbering }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.title }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.station ? item.station.name : "-" }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.type ? item.type.name : "-" }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.scope ? item.scope.name : "-" }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.last_status ? item.last_status.name : "-" }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.revision_version }}
                  </span>
                </td>

                <td>
                  <span
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.version }}
                  </span>
                </td>

                <td>
                  <span
                    v-if="!isEdit(item.id)"
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.receiver }}
                  </span>

                  <input
                    v-else
                    class="form-control"
                    v-model="currentEditForm.receiver"
                  />
                </td>

                <td>
                  <span
                    v-if="!isEdit(item.id)"
                    class="text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.date_receive }}
                  </span>

                  <input
                    v-else
                    class="form-control"
                    type="date"
                    v-model="currentEditForm.date_receive"
                    id="example-date-input"
                  />
                </td>

                <td class="pr-0">
                  <div class="d-flex">
                    <a
                      v-if="!isEdit(item.id)"
                      class="btn btn-light-success font-weight-bolder font-size-sm mr-2"
                      @click="editData(item)"
                    >
                      <i class="flaticon-edit"></i>
                    </a>

                    <a
                      v-if="isEdit(item.id)"
                      class="btn btn-light-danger font-weight-bolder font-size-sm mr-2"
                      @click="cancelEdit()"
                    >
                      <i class="flaticon2-cross"></i>
                    </a>
                  </div>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import { GET_PROJECT_DETAIL } from "../../../core/services/store/project.module";
import {
  GET_MONITORING_LOGISTIC,
  UPDATE_MONITORING_LOGISTIC
} from "../../../core/services/store/monitoring-logistic.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { GET_PIC } from "../../../core/services/store/pic.module";

export default {
  name: "MonitoringLogistic",
  components: { CompleteTable },
  data() {
    return {
      filter: {
        id_project: null,
        nickname: null,
        station: null,
        scope: null,
        job_desk: "design",
        code: null
      },
      currentEditId: null,
      currentEditForm: {
        receiver: null,
        date_receive: null
      },
      currentItem: null,
      selectedNickname: {
        ownerName: null,
        projectName: null,
        status: null,
        contractNumber: null,
        code: null
      },
      options: {
        nicknames: [
          { value: null, text: "Pilih Nickname" },
          { value: "1", text: "Makpa 1" },
          { value: "2", text: "Makpa 2" }
        ],
        stations: [
          { value: null, text: "Pilih Stasiun" },
          { value: "1", text: "LRS0123123" },
          { value: "2", text: "LRS0000001" }
        ],
        scopes: [
          { value: null, text: "Pilih Scope" },
          { value: "1", text: "HMI" },
          { value: "2", text: "CHIEF" }
        ],
        pics: [
          {
            value: 1,
            text: "Tan"
          },
          {
            value: 2,
            text: "Snow"
          },
          {
            value: 3,
            text: "Grow"
          }
        ]
      },
      data: {
        projects: [
          {
            numbering: "TAN-E29-105100",
            title: "Block Control Rack (BCR)",
            type: "Document",
            scope: "HMI",
            station: "Tan",
            date_received: null,
            receiver: null,
            status: "open",
            revision: "00",
            version: "00",
            is_edit: false
          }
        ]
      }
    };
  },
  computed: {
    ...mapState({
      projects: state => state.projectDetails.projectDetails?.data,
      monitoringLogistics: state => state.monitoringLogistic.data?.data,
      loading: state => state.monitoringLogistic.loading,
      pics: state => state.pic.pics?.data
    }),

    currentNickname() {
      return this.filter.nickname;
    },

    formattedProjectOptions() {
      let projects = [];

      if (arrayMoreThanOne(this.projects)) {
        projects = this.projects.map(project => {
          return {
            value: project.code,
            text: project.nickname
          };
        });
      }

      return [{ value: null, text: "Pilih Nickname" }, ...projects];
    },

    formattedPicOptions() {
      let pics = [];

      if (arrayMoreThanOne(this.pics)) {
        pics = this.pics.map(pic => {
          return {
            value: pic.code,
            text: pic.name
          };
        });
      }

      return [{ value: null, text: "Pilih PIC" }, ...pics];
    }
  },
  watch: {
    currentNickname(value) {
      if (!value) {
        Object.assign(this.selectedNickname, {
          ownerName: null,
          projectName: null,
          status: null,
          contractNumber: null,
          code: null
        });

        return;
      }

      const project = this.projects.find(
        project => project.code === this.filter.nickname
      );

      Object.assign(this.selectedNickname, {
        ownerName: project?.owner,
        projectName: project?.name,
        status: project?.status,
        contractNumber: project?.contract_no,
        ...project
      });
    }
  },
  methods: {
    toEditPage() {
      //
    },

    loadData() {
      if (!this.filter.nickname) {
        this.$bvToast.toast("Pilih nickname terlebih dahulu.", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      } else {
        this.$store.dispatch(GET_MONITORING_LOGISTIC, {
          params: {
            ...this.filter,
            project_code: this.currentNickname
          }
        });
      }
    },

    save() {
      const cleanForm = [
        {
          id: this.currentItem.id,
          ...this.currentEditForm
        }
      ];

      this.$store
        .dispatch(UPDATE_MONITORING_LOGISTIC, { dld: cleanForm })
        .then(() => {
          this.cancelEdit();
        });
    },

    editData(item) {
      this.currentEditId = item.id;

      this.currentItem = item;

      this.currentEditForm = {
        receiver: item.receiver?.toLowerCase(),
        date_receive: item.date_receive
      };
    },

    cancelEdit() {
      this.currentEditId = null;

      this.currentEditForm = {
        receiver: null,
        date_receive: null
      };

      this.currentItem = null;
    },

    isEdit(id) {
      return id === this.currentEditId;
    },

    getProjects() {
      if (!arrayMoreThanOne(this.projects)) {
        this.$store.dispatch(GET_PROJECT_DETAIL, { jobdesk: "design" });
      }
    },

    getPics() {
      if (!arrayMoreThanOne(this.pics)) {
        this.$store.dispatch(GET_PIC, {});
      }
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Monitoring Logistik" }]);

    this.getProjects();
  }
};
</script>

<style></style>
